<?php
/** Zend_Controller_Action */
require_once 'Zend/Controller/Action.php';

class LivreController extends Zend_Controller_Action
{
	public function indexAction()
	{
		$livre = new livre();
		$this->view->livres = $livre->fetchAll();
	}

	public function ajouterAction()
	{
		$this->view->title .= ' .: Ajout d\'un message';
		if ($this->getRequest()->isPost())
		{
			Zend_Loader::loadClass('Zend_Filter_StripTags');
			$filter = new Zend_Filter_StripTags();

			$livre = $this->_getEmptyMsg();
			$livre->id = null;
			$livre->nom = trim($filter->filter($this->getRequest()->getPost('nom')));
			$livre->site = trim($filter->filter($this->getRequest()->getPost('site')));
			$livre->site = str_replace('http://', '', $livre->site);
			$livre->email = trim($filter->filter($this->getRequest()->getPost('email')));
			$livre->message = trim($filter->filter($this->getRequest()->getPost('message')));
			$livre->ip = $this->getRequest()->getServer('REMOTE_ADDR');
			if ($livre->nom != htmlspecialchars('Pseudo'))
			{
				$livre_ = new Livre();
				$livre_->insertObject($livre);
				
				$this->_redirect('/livre');
				return;
			}
			else
			{
				$this->view->message = 'Merci de donner votre pseudo!';
			}
		}

		//création d'un message vide
		$this->view->livre = $this->_getEmptyMsg();
	}

	public function modifierAction()
	{
		//si on est aps connecter ->redirection sur le logeur
		if (!$_SESSION['connecter'])
			$this->getResponse()->setRedirect($this->view->baseUrl . '/livre/admin/');

		$this->view->title .= ' .: Modification d\'un message';

		//récupération du message correspondant au paramètre id
		$livreTable = new Livre();
		$where  = $livreTable->getAdapter()->quoteInto('id = ?', intval($this->getRequest()->getParam('id')));
		$livre = $livreTable->fetchRow($where);

		if ($this->getRequest()->isPost())
		{
			Zend_Loader::loadClass('Zend_Filter_StripTags');
			$filter = new Zend_Filter_StripTags();
			$livre->nom = trim($filter->filter($this->getRequest()->getPost('nom')));
			$livre->site = trim($filter->filter($this->getRequest()->getPost('site')));
			$livre->site = str_replace('http://', '', $livre->site);
			$livre->email = trim($filter->filter($this->getRequest()->getPost('email')));
			$livre->message = trim($filter->filter($this->getRequest()->getPost('message')));
			if ($livre->nom != htmlspecialchars('Pseudo'))
			{
				$livre_ = new Livre();
				$livre_->updateObject($livre, $livre_->getAdapter()->quoteInto('id = ?', $livre->id));
				$this->_redirect('/livre/');
				return;
			}
		}

		$this->view->livre = $livre;
		$this->view->action .= '/id/' . $livre->id;
		$this->render('ajouter');
	}

	public function adminAction()
	{
		$this->view->title .= ' .: Administration';
		if ($this->getRequest()->isPost() && !$_SESSION['connecter'])
		{
			if ($this->getRequest()->getPost('login') == 'admin' && $this->getRequest()->getPost('pass') == '1234')
			{
				//bon password et bon login
				$_SESSION['connecter'] = true;
			}
		}
		elseif (!$_SESSION['connecter'])
		{
			$this->render();
			return;
		}
		$this->getResponse()->setRedirect($this->view->baseUrl . '/livre/');
	}

	public function disadminAction()
	{
		$this->view->title .= ' .: Déconnection';
		if ($_SESSION['connecter'])
		{
			$_SESSION['connecter'] = false;
		}
		$this->getResponse()->setRedirect($this->view->baseUrl . '/livre/');
	}

	public function supprimerAction()
	{
		//si on est aps connecter ->redirection sur le logeur
		if (!$_SESSION['connecter'])
			$this->getResponse()->setRedirect($this->view->baseUrl . '/livre/admin/');

		$this->view->title .= ' .: Suppretion d\'un message';

		$livre = $this->_getEmptyMsg();
		$livre->id = intval($this->getRequest()->getParam('id'));
		$this->view->action .= '/id/' . $livre->id;

		if ($this->getRequest()->isPost())
		{
			$livre_ = new Livre();
			if ($livre_->delete($livre_->getAdapter()->quoteInto('id = ?', $livre->id)))
				$this->view->message = 'Message supprimé!';
			else
				$this->view->message = 'Message <b>non</b> supprimé!';
			$this->view->message .= '<br /> Vous aller être rediriger!<br />';
			$this->getResponse()->setRawHeader('Refresh:3; url=' . $this->view->baseUrl . '/livre/');
		}
	}

	function init()
	{
		session_name('goldbook');
		session_start();
		$_SESSION['connecter'] = isset($_SESSION['connecter'])?$_SESSION['connecter']:false;
		$this->view->connecter = $_SESSION['connecter'];

		$this->view->title = 'Livre d\'or';
		//url de base...
		$this->view->baseUrl = $this->_request->getBaseUrl();
		$this->view->action = $this->getRequest()->getActionName();
		//prêt à travailler sur les livres
		Zend_Loader::loadClass('Livre');
		//ajout des aides de view
		$this->view->addHelperPath('./app/views/helpers', 'MyWsp_View_Helper');
		$this->view->setEscape('utf8_encode');
	}

	/**
	 * Créer un message vide
	 *
	 * @return Object
	 */
	protected function _getEmptyMsg()
	{
		//création d'un message vide
		$livre = new stdClass();
		$livre	->id = -99;
		$livre	->nom = 'Pseudo';
		$livre	->site = 'www.monsite.com';
		$livre	->email = 'email@host.com';
		$livre	->message = 'Entrez votre message';
		$livre	->ip = '';
		$livre	->date = time();
		return $livre;
	}
}

